import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import HttpSuccess from "../interfaces/http-success";
import HttpStatus from "../interfaces/http-status";
import HttpError from "../interfaces/http-error";
import { ProfileNopaidHistory } from "../entities/ProfileNopaidHistory";
import { RequestWithUser } from "../middlewares/user";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import {
  CreateProfileEmployeeNopaid,
  ProfileNopaid,
  UpdateProfileNopaid,
} from "../entities/ProfileNopaid";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-employee/nopaid")
@Tags("ProfileNopaid")
@Security("bearerAuth")
export class ProfileNopaidEmployeeController extends Controller {
  private profileRepository = AppDataSource.getRepository(ProfileEmployee);
  private nopaidRepository = AppDataSource.getRepository(ProfileNopaid);
  private nopaidHistoryRepository = AppDataSource.getRepository(ProfileNopaidHistory);

  @Get("user")
  public async getNopaidUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileRepository.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const lists = await this.nopaidRepository.find({
      where: { profileEmployeeId: profile.id, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(lists);
  }

  @Get("{profileId}")
  public async getNopaid(@Path() profileId: string, @Request() req: RequestWithUser) {
    let _workflow = await new permission().Workflow(req, profileId, "SYS_REGISTRY_EMP");
    if (_workflow == false) await new permission().PermissionGet(req, "SYS_REGISTRY_EMP");
    const lists = await this.nopaidRepository.find({
      where: { profileEmployeeId: profileId, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(lists);
  }

  @Get("history/{nopaidId}")
  public async nopaidHistory(@Path() nopaidId: string, @Request() req: RequestWithUser) {
    let _workflow = await new permission().Workflow(req, nopaidId, "SYS_REGISTRY_EMP");
    if (_workflow == false) await new permission().PermissionGet(req, "SYS_REGISTRY_EMP");
    const record = await this.nopaidHistoryRepository.find({
      where: { profileNopaidId: nopaidId },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Post()
  public async newNopaid(
    @Request() req: RequestWithUser,
    @Body() body: CreateProfileEmployeeNopaid,
  ) {
    if (!body.profileEmployeeId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileId");
    }

    const profile = await this.profileRepository.findOneBy({ id: body.profileEmployeeId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_EMP", profile.id);
    const before = null;
    const data = new ProfileNopaid();

    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileNopaidHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.nopaidRepository.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileNopaidId = data.id;
    await this.nopaidHistoryRepository.save(history, { data: req });

    return new HttpSuccess(data.id);
  }

  @Patch("{nopaidId}")
  public async editNopaid(
    @Request() req: RequestWithUser,
    @Body() body: UpdateProfileNopaid,
    @Path() nopaidId: string,
  ) {
    const record = await this.nopaidRepository.findOneBy({ id: nopaidId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionOrgUserUpdate(
      req,
      "SYS_REGISTRY_EMP",
      record.profileEmployeeId,
    );

    const before = structuredClone(record);
    const history = new ProfileNopaidHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileNopaidId = nopaidId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    this.nopaidRepository.save(record, { data: req });
    setLogDataDiff(req, { before, after: record });
    if (!(Object.keys(body).length === 1 && body.isUpload)) {
      this.nopaidHistoryRepository.save(history, { data: req });
      // setLogDataDiff(req, { before, after: history });
    }

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลบันทึกวันที่ไม่ได้รับเงินเงินเดือนฯ
   * @summary API ลบข้อมูลบันทึกวันที่ไม่ได้รับเงินเงินเดือนฯ
   * @param nopaidId คีย์บันทึกวันที่ไม่ได้รับเงินเงินเดือนฯ
   */
  @Patch("update-delete/{nopaidId}")
  public async updateIsDeleted(
    @Request() req: RequestWithUser,
    @Path() nopaidId: string,
  ) {
    const record = await this.nopaidRepository.findOneBy({ id: nopaidId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionOrgUserDelete(req, "SYS_REGISTRY_EMP", record.profileEmployeeId);
    const before = structuredClone(record);
    const history = new ProfileNopaidHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.profileNopaidId = nopaidId;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.nopaidRepository.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.nopaidHistoryRepository.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{nopaidId}")
  public async deleteNopaid(@Path() nopaidId: string, @Request() req: RequestWithUser) {
    const _record = await this.nopaidRepository.findOneBy({ id: nopaidId });
    if (_record) {
      await new permission().PermissionOrgUserDelete(
        req,
        "SYS_REGISTRY_EMP",
        _record.profileEmployeeId,
      );
    }

    await this.nopaidHistoryRepository.delete({
      profileNopaidId: nopaidId,
    });

    const result = await this.nopaidRepository.delete({ id: nopaidId });

    if (result.affected == undefined || result.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }
}
